/*!
@file map_chip.hpp
@file マップチップのデータ構造
@note
*/
#ifndef DKUTIL_GRAPHICS_2D_MAPCHIP_HPP
#define DKUTIL_GRAPHICS_2D_MAPCHIP_HPP

#include <dkutil/boost/parm_string.hpp>
#include <dkutil/graphics/2d/map_chip.h>


namespace dkutil{
namespace graphics{

class MapChipData{
	DKC_GRAPHICS_2D_MAP_CHIP_STATE *mS;
	void check__(){
		if(!mS){
			DKUTIL_THROW_OR_NOTICE(std::runtime_error("MapChipData object pointer is NULL"));
		}
	}
	byte_buffer
public:
	typedef size_t size_type;
	
	MapChipData(parm_string filename,const BYTE *dustbin,size_type dustsize){
		mS = NULL;
		reset(dustbin,dustsize);
	}
	
	bool reset(const BYTE *dustbin,size_type dustsize){
		clear();
		mS = dkcAllocGraphics2DMapChip();
		return mS != NULL;
	}
	void clear(){
		dkcFreeGraphics2DMapChip(&mS);	
	}
	
	bool load(parm_string filename){
		int r = dkcGraphics2DMapChipLoad(filename)	
	}
	void *get()const{}
	size_type size()const{}
	
	
};

}//end of namespace graphics
}//end of dkutil namespace



#endif